##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE = 20 2 3 6 9 11 13 15 16 18 0 21 23 24 25 26
PALETTE2 = 0 2 3 6 9 11 13 15 16 18 20 21 23 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

### CONFIGURACIÓN GENERAL MENU ###
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites/ ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE2)          ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE2), pal_main2 ))
$(eval $(call IMG2SP, SET_IMG_FORMAT, screen))
$(eval $(call IMG2SP, SET_OUTPUT, bin))

$(eval $(call IMG2SP, CONVERT, assets/menus/MenusMenu.png, 0, 0, screen_menu))
$(eval $(call IMG2SP, CONVERT, assets/menus/MenusControles.png, 0, 0, screen_controles))
$(eval $(call IMG2SP, CONVERT, assets/menus/MenusCreditos.png, 0, 0, screen_creditos))

### CONFIGURACIÓN GENERAL SPRITES ###
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites/ ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)          ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), pal_main ))
$(eval $(call IMG2SP, SET_IMG_FORMAT, sprites))
$(eval $(call IMG2SP, SET_OUTPUT, c))
##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

#PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#############################################################
######################## SPRITES ########################
#############################################################

### GENERALES
$(eval $(call IMG2SP, CONVERT, assets/bonus/Puntuacion.png, 10, 10, bonus,))
$(eval $(call IMG2SP, CONVERT, assets/end.png, 12, 56, endMapa,))
$(eval $(call IMG2SP, CONVERT, assets/EndBordeSprite.png, 2, 114, colisionFinal,))
$(eval $(call IMG2SP, CONVERT, assets/muerte.png, 28, 24, muerte,))

$(eval $(call IMG2SP, CONVERT, assets/bloques/GroundBig.png, 80, 30, ground,))
$(eval $(call IMG2SP, CONVERT, assets/bloques/GroundBigDesierto.png, 80, 30, groundDesierto,))
$(eval $(call IMG2SP, CONVERT, assets/bloques/GroundBigHalloween.png, 80, 30, groundHalloween,))


### PLAYER
$(eval $(call IMG2SP, CONVERT, assets/player/walking.png, 10, 16, walking, ))
$(eval $(call IMG2SP, CONVERT, assets/player/saltando.png, 10, 16, doggoJump, ))
$(eval $(call IMG2SP, CONVERT, assets/player/agachado.png, 10, 11, crouched, ))



######## ENEMIGOS PAISAJE PRADO ########
$(eval $(call IMG2SP, CONVERT, assets/bloques/prado.png, 12, 16, bloque_prado,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/EPradoNormal.png, 8, 5, pradoBird,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/IA-EPradoSeguir.png, 8, 13, pradoRedBird,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/Tree2.png, 24, 32, arbol2,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/Tree3.png, 16, 48, arbol3,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/Tree4.png, 16, 64, arbol4,))

$(eval $(call IMG2SP, CONVERT, assets/bonus/RelentizarPrado.png, 10, 10, ralenPrado,))




###ENEMIGOS PAISAJE DESIERTO
$(eval $(call IMG2SP, CONVERT, assets/bloques/desierto.png, 12, 16, bloque_desierto,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/EDesiertoNormal.png, 8, 5, desiertoBird,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/IA-EDesiertoSeguir.png, 8, 13, desiertoIABird,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/Cactus2.png, 24, 32, cactus2,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/Cactus3.png, 16, 48, cactus3,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/Cactus4.png, 16, 64, cactus4,))

$(eval $(call IMG2SP, CONVERT, assets/bonus/RelentizarDesierto.png, 10, 10, ralenDes,))



###ENEMIGOS PAISAJE HALLOWEEN
$(eval $(call IMG2SP, CONVERT, assets/bloques/halloween.png, 12, 16, bloque_halloween,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/EHalloweenNormal.png, 8, 5, halloweenBird,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/IA-EHalloweenSeguir.png, 8, 13, halloweenIABird,))

$(eval $(call IMG2SP, CONVERT, assets/enemigos/HArbol2.png, 24, 32, hallArbol2,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/HArbol3.png, 16, 48, hallArbol3,))
$(eval $(call IMG2SP, CONVERT, assets/enemigos/HArbol4.png, 16, 64, hallArbol4,))

$(eval $(call IMG2SP, CONVERT, assets/bonus/RelentizarHalloween.png, 10, 10, ralenHallo,))


###MENÚS
#$(eval $(call IMG2SP, CONVERT, assets/GameOver.png, 80, 100, game_over,))
#$(eval $(call IMG2SP, CONVERT, assets/Menu.png, 160, 200, menu,))
#$(eval $(call IMG2SP, CONVERT, assets/controles.png, 160, 200, controles,))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################