;; MIT License
;; 
;; Copyright (c) 2021 capAI / Aitana Devis  Ávila (@AitanaDevis) / Carlos Peñarrubia Morcillo  (@carlospm12) / Pablo Ruiz Ponce (@pabloruizp)
;; 
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;; 
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "cpctelera.h.s"
.include "../man/sprites.h.s"
.include "../man/entity.h.s"

.globl _sys_ai_update_top_down
.globl _sys_ai_update_following
.globl _slow_game
.globl _add_20_score
.globl _add_10_score

.area _DATA

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                               ;;
;;                       MAPAS OFICIALES                         ;;
;;                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; MAPA 1 - TUTORIAL APRENDER A SALTAR
;;
;; DURACION ESTIMADA: 20 s
;;
_mapa1:: 
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H     E_PREV  E_SPR        E_AI_COUNTER
DefineEntity 4,  0,    0, 138,  0,    80,     6,  16*2,     0,    #_arbol2, 0  
DefineEntity 4,  0,    0, 138,  0,    160,    6,  16*2,     0,    #_arbol2, 0  
DefineEntity 8,  0,    0, 154, 0,     180,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 4,  0,    0, 138,  0,    230,    6,  16*2,     0,    #_arbol2, 0  
DefineEntity 8,  0,    0, 154, 0,     240,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 4,  0,    0, 138,  1,    20,     6,  16*2,     0,    #_arbol2, 0  
DefineEntity 4,  0,    0, 122,  1,    60,     6,  16*3,     0,    #_arbol3, 0
DefineEntity 8,  0,    0, 154, 1,     90,     5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 4,  0,    0, 138,  1,    120,    6,  16*2,     0,    #_arbol2, 0  
DefineEntity 4,  0,    0, 106,  1,    190,    6,  16*4,     0,    #_arbol4, 0

DefineEntity 16, 0,    0, 114,  2,    60,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  2,    66,  1,  114,0, #_colisionFinal, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;; MAPA 2 - TUTORIAL PLATAFORMAS
;;
;; DURACION ESTIMADA: 20 s
;;
_mapa2::
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H  E_PREV  E_SPR        E_AI_COUNTER
DefineEntity 2,  0,    0, 120, 0,     124,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 8,  0,    0, 110,  0,    126,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 120, 0,     128,    6,  16,     0,    #_bloque_prado, 0

DefineEntity 2,  0,    0, 120, 0,     194,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 120, 0,     198,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 8,  0,    0, 110,  0,    202,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 120, 0,     202,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 120, 0,     206,    6,  16,     0,    #_bloque_prado, 0

DefineEntity 2,  0,    0, 100, 1,     130,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 100, 1,     134,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 100, 1,     138,    6,  16,     0,    #_bloque_prado, 0

DefineEntity 2,  0,    0, 85, 1,     162,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 85, 1,     166,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 8,  0,    0, 70, 1,     167,    5,  10,     #_add_20_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 85, 1,     167,    6,  16,     0,    #_bloque_prado, 0


DefineEntity 2,  0,    0, 120, 2,     2,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 120, 2,     6,    6,  16,     0,    #_bloque_prado, 0


DefineEntity 2,  0,    0, 85, 2,     30,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 85, 2,     34,    6,  16,     0,    #_bloque_prado, 0


DefineEntity 2,  0,    0, 60, 2,     54,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 8,  0,    0, 50, 2,     58,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 60, 2,     58,    6,  16,     0,    #_bloque_prado, 0


DefineEntity 2,  0,    0, 85, 2,     100,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 85, 2,     104,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 2,  0,    0, 60, 2,     112,    6,  16,     0,    #_bloque_prado, 0
DefineEntity 8,  0,    0, 50, 2,     114,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 60, 2,     116,    6,  16,     0,    #_bloque_prado, 0

;; ESTARIA BIEN PONER EN EL SUELO ALGUN ARBOL PARA FORZAR A LA PERSONA A TENER QUE USAR LAS PLATAFORMAS

DefineEntity 16, 0,    0, 114,   2,    240,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  2,    247,  1,  114,0, #_colisionFinal, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;; MAPA 3 - TUTORIAL ENEMIGOS + IA + RALENTIZAR
;;
;; DURACION ESTIMADA: 20 s
;;
_mapa3::
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H  E_PREV  E_SPR        E_AI_COUNTER
DefineEntity 4,  0,    1, 110,  0,     80,  4,  5,              0,              #_pradoBird,      0   
DefineEntity 4,  0,    1, 150,  0,     160,  4,  5,              0,              #_pradoBird,      0   

DefineEntity 4,  0,    1, 150,  0,     220,  4,  5,              0,              #_pradoBird,      0   
DefineEntity 8,  0,    0, 154,  0,     230,    5,  10,     #_add_10_score,       #_bonus, 0 
DefineEntity 4,  0,    1, 110,  0,     240,  4,  5,              0,              #_pradoBird,      0  
DefineEntity 4,  0,    1, 125,  0,     250,  4,  5,              0,              #_pradoBird,      0  

DefineEntity 4,  0,    1, 150,  1,     80,  4,  5,              0,              #_pradoBird,      0   
DefineEntity 4,  0,    0, 106,  1,     120,    6,  16*4,         0,              #_arbol4, 0
DefineEntity 4,  0,    1, 160,  1,     180,  4,  5,              0,              #_pradoBird,      0   
DefineEntity 4,  0,    1, 140,  1,     195,  4,  5,              0,              #_pradoBird,      0  
DefineEntity 8,  0,    0, 154,  1,     195,    5,  10,     #_add_20_score,       #_bonus, 0 


;; EN 58 colisiona
DefineEntity 4,  1,    2, 150,  2,     58,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  2,     138,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 8,  0,    0, 154,  2,     150,    5,  10,     #_add_20_score,       #_bonus, 0 
DefineEntity 4,  0,    1, 120,  2,     160,  4,  5,              0,              #_pradoBird,      0  

;; TODO
DefineEntity 4,  1,    2, 150,  3,     0,  4,  13, #_sys_ai_update_following,   #_pradoRedBird,      0   
DefineEntity 8,  0,    0, 154,  3,     30,    5,  10,     #_add_20_score,       #_bonus, 0 

DefineEntity 4,  1,    2, 150,  3,     138,  4,  13, #_sys_ai_update_following,   #_pradoRedBird,      0   
DefineEntity 4,  0,    1, 120,  3,     160,  4,  5,              0,              #_pradoBird,      0  


DefineEntity 16, 0,    0, 114,   4,    0,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  4,    6,  1,  114,0, #_colisionFinal, 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;; MAPA 4 - COMBINACION DE CONCEPTOS
;;
;; DURACION ESTIMADA: 20 s
;;
_mapa4::
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H  E_PREV           E_SPR                   E_AI_COUNTER
DefineEntity 2,  0,    0, 120, 0,     70,    6,  16,     0,                 #_bloque_prado,  0
DefineEntity 8,  0,    0, 110, 0,     71,    5,  10,     #_add_10_score,    #_bonus,            0
DefineEntity 2,  0,    0, 120, 0,     74,    6,  16,     0,                 #_bloque_prado,  0

DefineEntity 4,  0,    0, 138,  0,    120,   6,  16*2,     0,               #_arbol2,          0  

DefineEntity 4,  0,    0, 138,  0,    180,   6,  16*2,     0,                    #_arbol2,     0  

DefineEntity 4,  0,    1, 154,  0,     220,  4,  5,             0,              #_pradoBird,      0  


DefineEntity 8,  0,    0, 154,  1,    25,   5,  10,      #_slow_game,           #_ralenPrado,    0   
DefineEntity 2,  0,    0, 120, 1,     54,    6,  16,     0,                 #_bloque_prado,  0
DefineEntity 2,  0,    0, 120, 1,     58,    6,  16,     0,                 #_bloque_prado,  0

DefineEntity 4, 0,    0, 122,  1,    70,   6,  16*3,          0,              #_arbol3, 0  


DefineEntity 4,  0,    0, 122,  1,    140,   6,  16*3,     0,                    #_arbol3,     0  
DefineEntity 2,  0,    0, 120, 1,     180,    6,  16,     0,                 #_bloque_prado,  0
DefineEntity 8,  0,    0, 110,  1,    182,    5,  10,     #_add_10_score,    #_bonus,            0
DefineEntity 2,  0,    0, 120, 1,     184,    6,  16,     0,                 #_bloque_prado,  0

DefineEntity 4,  1,    2, 140,  1,    210,   4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  0,    0, 138,  1,    230,   6,  16*2,          0,              #_arbol2, 0  

DefineEntity 8,  0,    0, 154,  2,    20,    5,  10,     #_add_10_score,    #_bonus,            0
DefineEntity 4,  0,    0, 138,  2,    30,   6,  16*2,          0,              #_arbol2, 0  
DefineEntity 8,  0,    0, 154,  2,    40,    5,  10,     #_add_10_score,    #_bonus,            0
DefineEntity 4,  0,    0, 138,  2,    50,   6,  16*2,          0,              #_arbol2, 0  


DefineEntity 2,  0,    0, 120,  2,     110,    6,  16,     0,                 #_bloque_prado,  0
DefineEntity 8,  0,    0, 110,  2,     111,    5,  10,     #_add_10_score,    #_bonus,            0
DefineEntity 2,  0,    0, 120,  2,     114,    6,  16,     0,                 #_bloque_prado,  0


DefineEntity 16, 0,    0, 114,   3,    0,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  3,    6,  1,  114,0, #_colisionFinal, 0



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;////////////////////////////////////////////////////////////////////////////////////
;; MAPA 5: 
;;      mapa simple, solo enemigos suelo. Ppio muy separados y conforme avanza se juntan más 
;;///////////////////////////////////////////////////////////////////////////////////
_mapa5::
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H  E_PREV  E_SPR             E_AI_COUNTER
DefineEntity 4,  0,    0, 138,  0,    80,      6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 138,  0,    160,     6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 138,  0,    240,     6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 138,  1,    20,      6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 122,  1,    60,      6,  16*3,     0,    #_cactus3, 0
DefineEntity 4,  0,    0, 138,  1,    100,     6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 106,  1,    190,     6,  16*4,     0,    #_cactus4, 0
;; TODO BIEN HASTA AQUI

DefineEntity 2,  0,    0, 120, 2,     2,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 2,  0,    0, 120, 2,     6,    6,  16,     0,    #_bloque_desierto, 0


DefineEntity 2,  0,    0, 85, 2,     30,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 8,  0,    0, 75, 2,     34,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 85, 2,     34,    6,  16,     0,    #_bloque_desierto, 0

;DefineEntity 4,  0,    1, 154,  2,     36,  4,  5,             0,              #_desiertoBird,      0  

DefineEntity 2,  0,    0, 120, 2,     44,    6,  16,     0,    #_bloque_desierto, 0




DefineEntity 4,  0,    0, 138,  2,    80,     6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 138,  2,    110,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 8,  0,    0, 154,  2,    125,    5,  10,     #_add_10_score,    #_bonus, 0
DefineEntity 4,  0,    0, 138,  2,    140,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 138,  2,    180,    6,  16*2,     0,    #_cactus2, 0


DefineEntity 4,  0,    0, 138,  2,    230,    6,  16*2,     0,    #_cactus2, 0  
DefineEntity 4,  0,    0, 138,  2,    240,    6,  16*2,     0,    #_cactus2, 0

DefineEntity 4,  0,    0, 138,  3,    30,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 122,  3,    50,    6,  16*3,     0,    #_cactus3, 0
DefineEntity 4,  0,    0, 138,  3,    80,    6,  16*2,     0,    #_cactus2, 0



DefineEntity 8,  0,    0, 154,  3,    110,    5,  10,     #_add_20_score,    #_bonus, 0 ;;add_20_score explota
DefineEntity 4,  0,    0, 138,  3,    120,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 8,  0,    0, 154,  3,    135,    5,  10,     #_add_10_score,    #_bonus, 0
DefineEntity 4,  0,    0, 138,  3,    150,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 8,  0,    0, 154,  3,    165,    5,  10,     #_add_10_score,    #_bonus, 0
DefineEntity 4,  0,    0, 106,  3,    180,    6,  16*4,     0,    #_cactus4, 0
DefineEntity 4,  0,    0, 138,  3,    220,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 138,  3,    240,    6,  16*2,     0,    #_cactus2, 0


DefineEntity 16, 0,    0, 114,   4,    0,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  4,    6,  1,  114,0, #_colisionFinal, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;////////////////////////////////////////
;; MAPA 6: 
;;      mapa con plataformas a distintos niveles 
;;///////////////////////////////////////
_mapa6::
;;          TIPO COMP  X    Y  OFF_L  OFF_H  E_W  E_H  E_PREV  E_SPR             E_AI_COUNTER
DefineEntity 2,  0,    0, 120, 0,     64,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 2,  0,    0, 120, 0,     68,    6,  16,     0,    #_bloque_desierto, 0


DefineEntity 8,  0,    0, 50,  0,     124,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 60, 0,     124,    6,  16,     0,    #_bloque_desierto, 0

DefineEntity 4,  1,    1, 150, 0,     170,  4,  13, #_sys_ai_update_following,  #_desiertoIABird,      0   

DefineEntity 2,  0,    0, 100, 0,     190,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 8,  0,    0, 154,  0,     194,    5,  10,     #_add_20_score,    #_bonus, 0 

DefineEntity 4,  0,    0, 138, 0,     250,    6,  16*2,     0,    #_cactus2, 0  
DefineEntity 8,  0,    0, 160, 1,     20,    5,  10,     #_add_10_score,    #_bonus, 0 
DefineEntity 4,  0,    0, 138, 1,     35,    6,  16*2,     0,    #_cactus2, 0  

DefineEntity 4,  0,    1, 154, 1,     80,  4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 1,     100,  4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 1,     120,  4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 1,     140,  4,  5,             0,              #_desiertoBird,      0  

DefineEntity 2,  0,    0, 120, 1,     170,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 2,  0,    0, 80, 1,     200,    6,  16,     0,    #_bloque_desierto, 0
DefineEntity 8,  0,    0, 30,  1,     230,    5,  10,     #_add_20_score,    #_bonus, 0 
DefineEntity 2,  0,    0, 40, 1,     230,    6,  16,     0,    #_bloque_desierto, 0


DefineEntity 4,  0,    0, 122,  1,    245,    6,  16*3,     0,    #_cactus3, 0


DefineEntity 8,   0,   0, 160,  2,     30,     5,   10,   #_slow_game,    #_ralenDes,      0 

DefineEntity 4,  1,    2, 150,  2,     52,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  2,     82,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  2,     112,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   


DefineEntity 4,  0,    0, 138,  2,    230,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 122,  2,    238,    6,  16*3,     0,    #_cactus3, 0
DefineEntity 4,  0,    0, 138,  2,    246,    6,  16*2,     0,    #_cactus2, 0


DefineEntity 4,  0,    0, 138,  3,    70,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 138,  3,    100,    6,  16*2,     0,    #_cactus2, 0
DefineEntity 4,  0,    0, 138,  3,    130,    6,  16*2,     0,    #_cactus2, 0


DefineEntity 8,   0,   0, 160,  3,     150,     5,   10,   #_slow_game,    #_ralenDes,      0 

DefineEntity 4,  1,    2, 150,  3,     170,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  3,     200,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  3,     230,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   


DefineEntity 16, 0,    0, 114,   4,    0,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  4,    6,  1,  114,0, #_colisionFinal, 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;////////////////
;;/// MAPA 7 /// ;; mapa con saltos + enemigos voladores 
;;///////////////
_mapa7:: 
;;          TIPO COMP  X    Y  OFF_L OFF_H  E_W  E_H  E_PREV                    E_SPR             E_AI_COUNTER
DefineEntity 2,   0,   0, 120, 0,     70,      6,   16,   0,                 #_bloque_halloween,    0 
DefineEntity 8,   0,   0, 108, 0,     71,       5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 2,   0,   0, 120, 0,     74,      6,   16,   0,                 #_bloque_halloween,    0   

DefineEntity 4,   0,   0, 138, 0,     130,      6,   16*2,   0,                 #_hallArbol2,    0   
DefineEntity 4,   1,   1, 138, 0,     170,      4,     13, #_sys_ai_update_top_down,   #_halloweenIABird,      0
DefineEntity 4,   0,   0, 138, 0,     185,      6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 4,   0,   0, 138, 0,     210,      6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 4,   0,   1, 102, 0,     212,      4,      5,   0,          #_halloweenBird,      0 

DefineEntity 4,   0,   0, 138, 0,     250,      6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 4,   0,   0, 138, 1,     20,       6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 8,   0,   0, 128, 1,     25,       5,   10,     #_add_20_score,    #_bonus,     0  

DefineEntity 4,   0,   0, 138, 1,     60,       6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 8,   0,   0, 128, 1,     70,       5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 4,   0,   0, 138, 1,     80,       6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 4,   0,   0, 106, 1,     140,      6,   16*4,   0,                 #_hallArbol4,    0
DefineEntity 4,   0,   0, 138, 1,     180,      6,   16*2,   0,                 #_hallArbol2,    0

DefineEntity 2,   0,   0, 120, 1,     240,      6,   16,   0,                 #_bloque_halloween,    0 
DefineEntity 8,   0,   0, 110, 1,     242,      5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 2,   0,   0, 120, 1,     244,      6,   16,   0,                 #_bloque_halloween,    0
DefineEntity 2,   0,   0, 120, 1,     248,      6,   16,   0,                 #_bloque_halloween,    0

DefineEntity 8,   0,   0, 154, 2,     42,      5,   10,     #_add_20_score,    #_bonus,     0  ;;si pilla el bonus se muere contra el cactus
DefineEntity 2,   0,   0, 130, 2,     40,      6,   16,   0,                 #_bloque_halloween,    0
DefineEntity 2,   0,   0, 130, 2,     44,      6,   16,   0,                 #_bloque_halloween,    0
DefineEntity 4,   0,   0, 138, 2,     56,      6,   16*2,   0,                 #_hallArbol2,    0

DefineEntity 4,   0,   0, 122, 2,     90,      6,   16*3,   0,                 #_hallArbol3,    0
DefineEntity 8,   0,   0, 154, 2,     115,      5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 4,   0,   0, 138, 2,     150,      6,   16*2,   0,                 #_hallArbol2,    0

DefineEntity 4,   0,   0, 122, 3,     45,      6,   16*3,   0,                 #_hallArbol3,    0   
DefineEntity 8,   0,   0, 154, 3,     60,      5,   10,     #_add_10_score,    #_bonus,     0  
DefineEntity 4,   0,   0, 138, 3,     80,      6,   16*2,   0,                 #_hallArbol2,    0 


DefineEntity 16, 0,    0, 114,   3,    200,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  3,    206,  1,  114,0, #_colisionFinal, 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;////////////////////////////
;;/// MAPA 8:                   
;;/// mapa halloween todo combinado 
;;///////////////////////////
_mapa8::
;;          TIPO COMP  X   Y  OFF_L  OFF_H     E_W  E_H   E_PREV                  E_SPR     E_AI_COUNTER
DefineEntity 4,   0,   0, 138,  0,     70,    6,   16*2,   0,    #_hallArbol2,      0
DefineEntity 4,   1,   1, 154,  0,     90,    4,     13, #_sys_ai_update_following,   #_halloweenIABird,      0
DefineEntity 4,   0,   0, 138,  0,     100,   6,   16*2,   0,    #_hallArbol2,      0 

DefineEntity 4,   0,   0, 138,  0,     148,   6,   16*2,   0,    #_hallArbol2,      0  
DefineEntity 8,   0,   0, 160,  0,     170,     5,   10,   #_slow_game,    #_ralenHallo,      0 

;;si suben aquí mueren contra el árbol de altura 4 que viene después
DefineEntity 2,   0,   0, 110,  0,     190,    6,   16,   0,    #_bloque_halloween,      0
DefineEntity 8,   0,   0, 100,  0,     192,     5,   10,   #_add_10_score,    #_bonus,      0 
DefineEntity 2,   0,   0, 110,  0,     194,    6,   16,   0,    #_bloque_halloween,      0

DefineEntity 4,   0,   0, 138,  0,     235,     6,   16*2,   0,    #_hallArbol2,      0 
DefineEntity 4,   0,   0, 106,  1,     20,     6,   16*4,   0,    #_hallArbol4,      0 
DefineEntity 4,   0,   0, 138,  1,     70,      6,   16*2,   0,    #_hallArbol2,      0 

;;*2: tiene que saltar a tiempo para no morir contra el árbol de altura 4 que viene después
DefineEntity 2,   0,   0, 120,  1,     112,    6,   16,   0,    #_bloque_halloween,      0
DefineEntity 4,   1,   1, 92,  1,     115,    4,     13, #_sys_ai_update_top_down,   #_halloweenIABird,      0 ;;si consigue esquivar al enemigo *2
DefineEntity 2,   0,   0, 120,  1,     116,    6,   16,   0,    #_bloque_halloween,      0
DefineEntity 4,  0,    1, 154,   1,     117,  4,     5,        0,          #_halloweenBird,      0 ;;*1: no le mata el enemigo
DefineEntity 2,   0,   0, 120,  1,     120,    6,   16,   0,    #_bloque_halloween,      0 

DefineEntity 4,   0,   0, 122, 1,     170,    6,   16*3,   0,    #_hallArbol3,      0 
DefineEntity 4,   0,   0, 138, 1,     210,    6,   16*2,   0,    #_hallArbol2,      0 
DefineEntity 8,   0,   0, 154, 1,     220,     5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 4,   0,   0, 138, 1,     235,    6,   16*2,   0,    #_hallArbol2,      0

DefineEntity 2,   0,   0, 120,  2,     10,    6,   16,   0,    #_bloque_halloween,     0
DefineEntity 8,   0,   0, 110,  2,     12,    5,   10,     #_add_20_score,    #_bonus,     0  ;;o pilla bonus en plataforma
DefineEntity 8,   0,   0, 154,  2,     12,    5,   10,     #_slow_game,    #_ralenHallo,     0  ;;o ralentizador
DefineEntity 2,   0,   0, 120,  2,     14,    6,   16,   0,    #_bloque_halloween,     0

DefineEntity 4,   0,   0, 122,  2,     40,    6,   16*3,   0,    #_hallArbol3,      0 

;;hacemos que se tenga que agachar sí o sí
DefineEntity 4,  0,    1, 154,   2,     70,  4,     5,        0,          #_halloweenBird,      0 ;;si no le mata el enemigo
DefineEntity 8,   0,   1, 154,   2,     80,  5,      10,   #_add_20_score,          #_bonus,      0 ;;que coja bonus

;;que tenga que hacer un salto perfecto para poder coger los bonus
DefineEntity 2,   0,   0, 120,  2,     150,    6,   16,   0,    #_bloque_halloween,     0
DefineEntity 8,   0,   0, 110,  2,     150,    5,   10,     #_add_20_score,    #_bonus,     0  

DefineEntity 2,   0,   0, 90,  2,     170,    6,   16,   0,    #_bloque_halloween,     0
DefineEntity 8,   0,   0, 80,  2,     170,    5,   10,     #_add_20_score,    #_bonus,     0  


DefineEntity 16, 0,    0, 114,   3,    0,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  3,    6,  1,  114,0, #_colisionFinal, 0



;;////////////////
;;/// MAPA 9 /// ;;mapa con todo tipo de entidades
;;///////////////
_mapa9::
;;          TIPO COMP  X   Y  OFF_L  OFF_H  E_W  E_H   E_PREV        E_SPR           E_AI_COUNTER
DefineEntity 4,  0,    1, 154, 0,     80,   4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 0,     100,  4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 0,     120,  4,  5,             0,              #_desiertoBird,      0  
DefineEntity 4,  0,    1, 154, 0,     140,  4,  5,             0,              #_desiertoBird,      0  

;;*2: tiene que saltar a tiempo para no morir contra el árbol de altura 4 que viene después
DefineEntity 2,   0,   0, 120,  0,     172,    6,   16,   0,                        #_bloque_halloween,      0
DefineEntity 8,   0,   0, 154,  0,     174,    5,   10,     #_add_20_score,         #_bonus,     0  ;;pilla bonus SI *1
DefineEntity 4,   1,   1, 92,   0,     175,    4,   13, #_sys_ai_update_top_down,   #_halloweenIABird,      0 ;;si consigue esquivar al enemigo *2
DefineEntity 2,   0,   0, 120,  0,     176,    6,   16,   0,                        #_bloque_halloween,      0
DefineEntity 4,  0,    1, 154,  0,     177,    4,    5,        0,                   #_halloweenBird,      0 ;;*1: no le mata el enemigo
;DefineEntity 4,   0,   0, 138,  0,     240,   6,   16*2,   0,    #_hallArbol2,      0 

DefineEntity 8,   0,   0, 160,  1,     30,     5,   10,   #_slow_game,    #_ralenDes,      0 
DefineEntity 4,  1,    2, 150,  1,     64,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  1,     94,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  1,     124,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   

DefineEntity 2,   0,   0, 120, 1,     244,      6,   16,   0,                 #_bloque_halloween,    0
DefineEntity 8,   0,   0, 110, 1,     244,      5,   10,     #_add_20_score,    #_bonus,     0  
DefineEntity 2,   0,   0, 120, 1,     248,      6,   16,   0,                 #_bloque_halloween,    0

DefineEntity 2,   0,   0, 130, 2,     40,      6,   16,   0,                 #_bloque_halloween,    0 ;;si no cuadra salto se come al enemigo
;DefineEntity 8,   0,   0, 154, 2,     42,      5,   10,     #_add_20_score,    #_bonus,     0  ;;si pilla el bonus se muere contra el cactus
DefineEntity 2,   0,   0, 130, 2,     44,      6,   16,   0,                 #_bloque_halloween,    0
DefineEntity 4,   0,   0, 138, 2,     56,      6,   16*2,   0,                 #_hallArbol2,    0

DefineEntity 4,   0,   0, 106,  2,     80,   6,   16*4,   0,    #_hallArbol4,      0 
DefineEntity 4,  0,    1, 154,  2,     107,  4,     5,        0,          #_halloweenBird,      0 
DefineEntity 4,   0,   0, 138,  2,     125,   6,   16*2,   0,    #_hallArbol2,      0 

DefineEntity 2,  0,    0, 120, 2,     170,    6,  16,       0,                    #_bloque_desierto,  0
DefineEntity 8,  0,    0, 138, 2,     170,    6,  16*2,     0,       #_hallArbol2,            0 

DefineEntity 2,  0,    0, 80,  2,     200,    6,  16,     0,                    #_bloque_desierto,  0
DefineEntity 8,  0,    0, 30,  2,     230,    5,  10,     #_add_20_score,       #_bonus,            0 
DefineEntity 2,  0,    0, 40,  2,     230,    6,  16,     0,                    #_bloque_desierto,  0

DefineEntity 4,   0,   0, 138,  3,     50,    6,   16*2,   0,                 #_hallArbol2,    0
DefineEntity 8,  0,    0, 120,  3,     52,    5,  10,     #_add_20_score,       #_bonus,            0 
DefineEntity 4,  0,    1, 154,  3,     70,    4,     5,        0,          #_halloweenBird,      0 

DefineEntity 4,   0,   0, 106,  3,     120,    6,   16*4,   0,                 #_hallArbol4,    0

DefineEntity 4,  1,    2, 150,  3,     170,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  3,     200,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   
DefineEntity 4,  1,    2, 150,  3,     230,  4,  13, #_sys_ai_update_top_down,   #_pradoRedBird,      0   


DefineEntity 16, 0,    0, 114,   4,    10,  6,  56, 0, #_endMapa, 0  
DefineEntity 16, 0,    0,   20,  4,    16,  1,  114,0, #_colisionFinal, 0